package com.aitrainer.api.controller

import com.aitrainer.api.model.OpenAI
import com.aitrainer.api.openai.OpenAIService
import kotlinx.coroutines.*
import org.slf4j.LoggerFactory
import org.springframework.web.bind.annotation.*

@RestController
@RequestMapping("/api")
class OpenAIController() {
    private val logger = LoggerFactory.getLogger(javaClass)

    @OptIn(DelicateCoroutinesApi::class)
    @PostMapping("/openai/completion")
    fun getOpenAIResponse(@RequestBody question: String) : String {
        var result = ""
        val openAIService = OpenAIService(null, null)
        val deferred = GlobalScope.async {
            openAIService.completion(question)
        }
        runBlocking {
            result = deferred.await()
            //println("Result: $result" )
        }
        return result
    }

    @OptIn(DelicateCoroutinesApi::class)
    @PostMapping("/openai/completion_with_model")
    fun getOpenAIResponseWithModel(@RequestBody openai: OpenAI) : String {
        var result = ""
        val openAIService = OpenAIService(openai.modelName, openai.temperature)
        val deferred = GlobalScope.async {
            openAIService.completion(openai.question)
        }
        runBlocking {
            result = deferred.await()
            //println("Result: $result" )
        }
        return result
    }

    @OptIn(DelicateCoroutinesApi::class)
    @GetMapping("/openai/list_models")
    fun getOpenAIModels(): MutableList<String> {
        var result = mutableListOf<String>()
        val openAIService = OpenAIService(null, null)
        val deferred = GlobalScope.async {
            openAIService.getModels()
        }
        runBlocking {
            result = deferred.await()
            //println("Result: $result" )
        }
        return result
    }
}

