package com.aitrainer.api.model

import com.google.gson.annotations.Expose
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import org.springframework.lang.NonNull
import jakarta.persistence.*
import javax.validation.constraints.NotBlank

@Entity
data class Property (
    @Expose @Id  @GeneratedValue(strategy = GenerationType.IDENTITY) @get: NonNull  var propertyId: Long = 0,
    @Expose @get: NotBlank  var propertyName: String = "",
    @Expose @get: NotBlank  var propertyUnit: String = ""
) {
        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "property")
        @Fetch(value = FetchMode.SUBSELECT)
        @Expose val translations: List<PropertyTranslation> = mutableListOf<PropertyTranslation>().toList()

}