package com.aitrainer.api.model

import com.google.gson.annotations.Expose
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import org.springframework.lang.NonNull
import jakarta.persistence.*
import javax.validation.constraints.NotBlank

@Entity
data class Tutorial (
    @Expose @Id  @GeneratedValue(strategy = GenerationType.IDENTITY) @get: NonNull  var tutorialId: Long = 0,
    @Expose @get: NotBlank  var name: String = "",
) {
        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "tutorial")
        @Fetch(value = FetchMode.SUBSELECT)
        @Expose val steps: List<TutorialSteps> = mutableListOf<TutorialSteps>().toList()

}